// DirectInput-Hook.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include <vcclr.h>
#include "NamedPipeClient.h"

#using "System.Windows.Forms.dll"

#pragma managed(push, off)

long SetDInputRegistryKey(const TCHAR* newValue)
{
	HKEY regKey = 0;
	if(ERROR_SUCCESS != RegCreateKeyEx(HKEY_CLASSES_ROOT, _T("CLSID\\{25E609E0-B259-11CF-BFC7-444553540000}\\InprocServer32"), 0, 0, 0, KEY_READ | KEY_WRITE,
		0, &regKey, 0))
	{
		return 2;
	}

	if(ERROR_SUCCESS != RegSetValueEx(regKey, 0, 0, REG_SZ, reinterpret_cast<const BYTE*>(newValue),
		(_tcsclen(newValue) + 1) * sizeof(TCHAR)))
	{
		return 3;
	}

	RegCloseKey(regKey);

	return 0;
}

long DoInstallProxy()
{
	TCHAR process[MAX_PATH + 1];
	GetModuleFileName(GetModuleHandle(0), process, 512);
	PathRemoveFileSpec(process);
	PathAppend(process, _T("DirectInputProxy.dll"));

	return SetDInputRegistryKey(process);
}

long DoRemoveProxy()
{
	return SetDInputRegistryKey(_T("dinput.dll"));
}

long DoSetTargetExecutable(const wchar_t* executable)
{
	// Create/update the registry entry
	HKEY regKey = 0;
	if(ERROR_SUCCESS != RegCreateKeyEx(HKEY_CURRENT_USER, L"Software\\DirectInputProxy", 0, 0, 0, KEY_READ | KEY_WRITE,
		0, &regKey, 0))
	{
		return 2;
	}

	if(ERROR_SUCCESS != RegSetValueEx(regKey, 0, 0, REG_SZ, reinterpret_cast<const BYTE*>(executable),
		(_tcsclen(executable) + 1) * sizeof(TCHAR)))
	{
		return 3;
	}

	return 0;
}

#include <iostream>

long DoSend(NamedPipeClient* pipe, unsigned int b)
{
	std::stringstream ss;
	ss << b;
	ss << " ";
	ss << std::ends;
	
	if (!pipe->Write(ss.str()))
	{
		return pipe->IsServerAvailable() ? 2 : 1;
	}
	else
	{
		return 0;
	}
}

#pragma managed(pop)

public ref class UnknownKeyException : public System::Exception
{
public:
	UnknownKeyException(System::Windows::Forms::Keys key)
	{
		mKey = key;
	}

	property System::Windows::Forms::Keys mKey;

};

unsigned int MapKeyToDirectXChar(System::Windows::Forms::Keys key)
{
	using namespace System::Windows::Forms;

	switch (key)
	{
	case Keys::Escape: return DIK_ESCAPE;
	case Keys::D1: return DIK_1;
	case Keys::D2: return DIK_2;
	case Keys::D3: return DIK_3;
	case Keys::D4: return DIK_4;
	case Keys::D5: return DIK_5;
	case Keys::D6: return DIK_6;
	case Keys::D7: return DIK_7;
	case Keys::D8: return DIK_8;
	case Keys::D9: return DIK_9;
	case Keys::D0: return DIK_0;
	case Keys::Subtract: return DIK_MINUS;
	case Keys::Back: return DIK_BACK;
	case Keys::Tab: return DIK_TAB;
	case Keys::A: return DIK_A;
	case Keys::B: return DIK_B;
	case Keys::C: return DIK_C;
	case Keys::D: return DIK_D;
	case Keys::E: return DIK_E;
	case Keys::F: return DIK_F;
	case Keys::G: return DIK_G;
	case Keys::H: return DIK_H;
	case Keys::I: return DIK_I;
	case Keys::J: return DIK_J;
	case Keys::K: return DIK_K;
	case Keys::L: return DIK_L;
	case Keys::M: return DIK_M;
	case Keys::N: return DIK_N;
	case Keys::O: return DIK_O;
	case Keys::P: return DIK_P;
	case Keys::Q: return DIK_Q;
	case Keys::R: return DIK_R;
	case Keys::S: return DIK_S;
	case Keys::T: return DIK_T;
	case Keys::U: return DIK_U;
	case Keys::V: return DIK_V;
	case Keys::W: return DIK_W;
	case Keys::X: return DIK_X;
	case Keys::Y: return DIK_Y;
	case Keys::Z: return DIK_Z;
	case Keys::Return: return DIK_RETURN;
	case Keys::Multiply: return DIK_MULTIPLY;
	case Keys::Space: return DIK_SPACE;
	case Keys::F1: return DIK_F1;
	case Keys::F2: return DIK_F2;
	case Keys::F3: return DIK_F3;
	case Keys::F4: return DIK_F4;
	case Keys::F5: return DIK_F5;
	case Keys::F6: return DIK_F6;
	case Keys::F7: return DIK_F7;
	case Keys::F8: return DIK_F8;
	case Keys::F9: return DIK_F9;
	case Keys::F10: return DIK_F10;
	case Keys::F11: return DIK_F11;
	case Keys::F12: return DIK_F12;
	case Keys::NumLock: return DIK_NUMLOCK;
	case Keys::Scroll: return DIK_SCROLL;
	case Keys::NumPad0: return DIK_NUMPAD0;
	case Keys::NumPad1: return DIK_NUMPAD1;
	case Keys::NumPad2: return DIK_NUMPAD2;
	case Keys::NumPad3: return DIK_NUMPAD3;
	case Keys::NumPad4: return DIK_NUMPAD4;
	case Keys::NumPad5: return DIK_NUMPAD5;
	case Keys::NumPad6: return DIK_NUMPAD6;
	case Keys::NumPad7: return DIK_NUMPAD7;
	case Keys::NumPad8: return DIK_NUMPAD8;
	case Keys::NumPad9: return DIK_NUMPAD9;
	case Keys::Home: return DIK_HOME;
	case Keys::End: return DIK_END;
	case Keys::Down: return DIK_DOWN;
	case Keys::Up: return DIK_UP;
	case Keys::Insert: return DIK_INSERT;
	case Keys::Delete: return DIK_DELETE;
	case Keys::Left: return DIK_LEFT;
	case Keys::Right: return DIK_RIGHT;
	case Keys::PageDown: return DIK_NEXT;
	case Keys::PageUp: return DIK_PRIOR;
	case Keys::Pause: return DIK_PAUSE;
	case Keys::VolumeDown: return DIK_VOLUMEDOWN;
	case Keys::VolumeUp: return DIK_VOLUMEUP;
	case Keys::VolumeMute: return DIK_MUTE;
	case Keys::OemPeriod: return DIK_PERIOD;
	case Keys::OemSemicolon: return DIK_SEMICOLON;
	case Keys::Oem4: return DIK_COLON;
	case Keys::Oemcomma: return DIK_COMMA;
	case Keys::Oem2: return DIK_UNDERLINE;
	case Keys::OemMinus: return DIK_MINUS;
	case Keys::Oem3: return DIK_SLASH;
	default:
		throw gcnew UnknownKeyException(key);
	}
}

public ref class DirectInputConnect
{
public:
	long InstallProxy()
	{
		return DoInstallProxy();
	}

	long UnnstallProxy()
	{
		return DoRemoveProxy();
	}

	long SetTargetExecutable(System::String^ executable)
	{
		pin_ptr<const wchar_t> chars = PtrToStringChars(executable);
		return DoSetTargetExecutable(chars);
	}

	long Connect(long timeout)
	{
		clientPipe = new NamedPipeClient(_T("\\\\.\\pipe\\DirectInputProxy"));
		long time = 0;
		while (time < timeout && !clientPipe->IsServerAvailable())
		{
			Sleep(10);
			time += 10;
		}
		if (!clientPipe->IsServerAvailable())
		{
			return 1;
		}
		if (clientPipe->Connect())
		{
			return 0;
		}
		else
		{
			return 2;
		}
	}

	long Disconnect()
	{
		clientPipe->Disconnect();
		delete clientPipe;
		clientPipe = NULL;
		return 0;
	}

	long Send(System::Windows::Forms::Keys key)
	{
		return DoSend(clientPipe, MapKeyToDirectXChar(key));
	}

	DirectInputConnect() : clientPipe(NULL) {}

	~DirectInputConnect() 
	{ 
		delete clientPipe; 
		clientPipe = NULL;
	}

private:
	NamedPipeClient* clientPipe;
};