#pragma once

#include "KeyboardDevice.h"

class MyDirectInput : public IDirectInput7
{
public:
	static ULONG sInstanceCount;

	MyDirectInput(IDirectInput7* di) : m_di(di)
	{
		++sInstanceCount;
	}

	/*** IUnknown methods ***/
    HRESULT STDMETHODCALLTYPE QueryInterface(REFIID riid, void** ppvObj);

    ULONG STDMETHODCALLTYPE AddRef()
	{
		return m_di->AddRef();
	}

    ULONG STDMETHODCALLTYPE Release()
	{
		ULONG count = m_di->Release();
		if(0 == count)
		{
			delete this;
			--sInstanceCount;
		}

		return count;
	}

    /*** IDirectInput methods ***/
    STDMETHOD(CreateDevice)(REFGUID rguid, IDirectInputDevice** device, LPUNKNOWN unknown);

    STDMETHOD(EnumDevices)(DWORD devType,LPDIENUMDEVICESCALLBACK callback, LPVOID ref, DWORD flags);

    STDMETHOD(GetDeviceStatus)(REFGUID rguid)
	{
		return m_di->GetDeviceStatus(rguid);
	}

    STDMETHOD(RunControlPanel)(HWND owner, DWORD flags)
	{
		return m_di->RunControlPanel(owner, flags);
	}

    STDMETHOD(Initialize)(HINSTANCE instance, DWORD version)
	{
		return m_di->Initialize(instance, version);
	}

	STDMETHOD(FindDevice)(REFGUID rguid, LPCWSTR str, LPGUID pGuid);

	STDMETHOD(CreateDeviceEx)(REFGUID rguid, REFIID riid, LPVOID * device, LPUNKNOWN unknown);

private:
	IDirectInput7* m_di;
};