#pragma once

class ProxyClassFactory : public IClassFactory
{
private:
	ULONG mRefCount;
public:
	static ULONG sInstanceCount;

	ProxyClassFactory() : mRefCount(0) { ++sInstanceCount; }

	/*** IUnknown methods ***/
	STDMETHOD(QueryInterface)(REFIID riid, void** ppvObj)
	{
		if (riid == IID_IClassFactory)
		{
			AddRef();
			*ppvObj = this;
			return S_OK;
		}
		else
		{
			return E_NOINTERFACE;
		}
	}

	STDMETHOD_(ULONG,AddRef)()
	{
		return ++mRefCount;
	}

	STDMETHOD_(ULONG,Release)()
	{
		if(0 == --mRefCount)
		{
			delete this;
			--sInstanceCount;
		}
		return mRefCount;
	}

	/** IClassFactory methods */
	STDMETHOD_(HRESULT, CreateInstance)(IUnknown* pUnkOuter, REFIID riid, void** ppvObject);

	STDMETHOD_(HRESULT, LockServer)(BOOL fLock)
	{
		return CoLockObjectExternal(this, fLock, FALSE);
	}

};