﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace RPGSoundController
{
    partial class OptionsDialog : Form
    {
        public OptionsDialog()
        {
            InitializeComponent();

            playerBox.Text = Options.Default.PlayerPath;
            tcpUpDown.Value = Options.Default.TcpListenPort;
            udpUpDown.Value = Options.Default.UdpPort;

            foreach (MessageType type in Enum.GetValues(typeof(MessageType))) 
            {
                filterBox.Items.Add(type);
            }
            if (Options.Default.MessageFilter <= (int)MessageType.Error)
            {
                filterBox.SelectedIndex = Options.Default.MessageFilter;
            }
            else
            {
                filterBox.SelectedIndex = (int)MessageType.Warning;
            }
        }


        private void okButton_Click(object sender, EventArgs e)
        {
            Options.Default.PlayerPath = playerBox.Text;
            Options.Default.TcpListenPort = (int)tcpUpDown.Value;
            Options.Default.UdpPort = (int)udpUpDown.Value;
            lock (Options.Default)
            {
                Options.Default.MessageFilter = filterBox.SelectedIndex;
            }
            DialogResult = DialogResult.OK;
            Close();
        }

        private void cancelButton_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
            Close();
        }

        private void selectButton_Click(object sender, EventArgs e)
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                playerBox.Text = openFileDialog1.FileName;
            }
        }
    }
}
